#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	brotli
Version		:	1.0.9
Release		:	14.8.0.0%{?dist}
Summary		:	Lossless compression algorithm

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	MIT
URL		:	https://github.com/google/brotli

Source0		:	%{name}-%{version}.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	gcc
BuildRequires	:	gcc-c++
BuildRequires	:	cmake
BuildRequires	:	python3
BuildRequires	:	python3-setuptools

#-----------------------------------------------------------------------------
%description
Brotli is a generic-purpose lossless compression algorithm that compresses
data using a combination of a modern variant of the LZ77 algorithm, Huffman
coding and 2nd order context modeling, with a compression ratio comparable
to the best currently available general-purpose compression methods.
It is similar in speed with deflate but offers more dense compression.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%{_bindir}/%{name}


#=============================================================================
%package -n		libbrotli
Summary		:	Library for brotli lossless compression algorithm
 

#-----------------------------------------------------------------------------
%description -n		libbrotli
Brotli is a generic-purpose lossless compression algorithm that compresses
data using a combination of a modern variant of the LZ77 algorithm, Huffman
coding and 2nd order context modeling, with a compression ratio comparable
to the best currently available general-purpose compression methods.
It is similar in speed with deflate but offers more dense compression.

#-----------------------------------------------------------------------------
%files -n		libbrotli
%defattr(-,root,root,-)
%license LICENSE
%{_libdir}/lib%{name}common.so.*
%{_libdir}/lib%{name}dec.so.*
%{_libdir}/lib%{name}enc.so.*

#=============================================================================
%package		devel
Summary		:	Lossless compression algorithm (development files)

Requires	:	%{name} = %{version}-%{release}
Requires	:	lib%{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
Brotli is a generic-purpose lossless compression algorithm that compresses
data using a combination of a modern variant of the LZ77 algorithm, Huffman
coding and 2nd order context modeling, with a compression ratio comparable
to the best currently available general-purpose compression methods.
It is similar in speed with deflate but offers more dense compression.
This package installs the development files
 

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}/*.h
%{_libdir}/lib%{name}common.so
%{_libdir}/lib%{name}dec.so
%{_libdir}/lib%{name}enc.so
%{_libdir}/pkgconfig/lib%{name}common.pc
%{_libdir}/pkgconfig/lib%{name}dec.pc
%{_libdir}/pkgconfig/lib%{name}enc.pc
%{_mandir}/man3/constants.h.3%{name}.gz
%{_mandir}/man3/decode.h.3%{name}.gz
%{_mandir}/man3/encode.h.3%{name}.gz
%{_mandir}/man3/types.h.3%{name}.gz

#=============================================================================
%package -n		python3-%{name}
Summary		:	Lossless compression algorithm (python 3)
 

#-----------------------------------------------------------------------------
%description -n		python3-%{name}
Brotli is a generic-purpose lossless compression algorithm that compresses
data using a combination of a modern variant of the LZ77 algorithm, Huffman
coding and 2nd order context modeling, with a compression ratio comparable
to the best currently available general-purpose compression methods.
It is similar in speed with deflate but offers more dense compression.
This package installs a Python 3 module.
 

#-----------------------------------------------------------------------------
%files -n		python3-%{name}
%license LICENSE
%{python3_sitearch}/%{name}.py
%{python3_sitearch}/_%{name}.cpython-%{python3_version_nodots}*.so
%{python3_sitearch}/__pycache__/%{name}.cpython-%{python3_version_nodots}*.py*
%{python3_sitearch}/Brotli-%{version}-py%{python3_version}.egg-info

#=============================================================================
%prep
%setup -q
sed -i 							\
  -e "s@-R..libdir.@@"					\
  scripts/*.pc.in


#-----------------------------------------------------------------------------
#building application
%build

cmake							\
	-DCMAKE_INSTALL_PREFIX="%{_prefix}"		\
    	-DCMAKE_INSTALL_LIBDIR="%{_libdir}"		\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	%{_smp_mflags}

python3							\
	setup.py					\
	build
#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install

python3							\
	setup.py					\
	install						\
	-O1						\
	--skip-build					\
	--root %{buildroot}				\

#installing manual
install -dm755 "%{buildroot}%{_mandir}/man3"
pushd docs
for i in *.3
  do
  install -m644						\
	"$i"						\
	"%{buildroot}%{_mandir}/man3/${i}brotli"
  done
popd

#To remove static library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.a					\
	-delete

#-----------------------------------------------------------------------------
%changelog
